import es, gamethread, random, effectlib, playerlib

### Start Config ###
colors = [[255, 0, 0], [0, 0, 255], [0, 255, 0], [255, 0, 255], [255, 255, 0], [0, 255, 255]] # RGB Color values of lasers
length_min = 50 # Minimum game units for laser
length_max = 350 # Maximum game units for laser
x_spin = 10 # How many degrees the ball spins on x axis every 0.1 seconds
y_spin = 10 # ""
z_spin = 10 # ""
admins = ['STEAM_0:0:20394923', 'STEAM_0:0:11089864'] # People who can start/stop disco
disco_fog_change_time = 2 # Time between fog changes color
fog_start_unit = 150 # How many units away from the persons screen they see the fog, the large it is, the less you see
fog_end_unit = 1000 # How many units away from the person the fog stops
enable_rick_rolled = 1 # Whether or not the "Rick Rolled" song will play
custom_sound = None # If not none, you can have custom sounds playing with disco so an example would be 'cow.wav' and you would have to put cow.wav under cstrike/addons/sound/disco/
### End Config ###

index, start_userid, prop_keys, origin = None, None, None, None

es.ServerVar('disco_version', 1, 'Disco made by Bonbon AKA Bonbon367').makepublic()

def load():
	if not es.exists('clientcommand', 'disco'):
		es.regclientcmd('disco', 'disco/disco')
	if not es.exists('clientcommand', 'stop_disco'):
		es.regclientcmd('stop_disco', 'disco/stop_stuff')
	add_sounds()

def es_map_start(ev):
	add_sounds()

def disco():
	userid = es.getcmduserid()
	if playerlib.getPlayer(es.getcmduserid()).get('steamid') in admins:
		if es.getargc() >= 4:
			global origin, prop_keys, start_userid
			start_userid = userid
			x, y, z = es.getargs().split(' ')
			origin = [float(x), float(y), float(z)]
			stop_stuff()
			prop_keys = list(es.createentitylist().keys())
			if len(playerlib.getUseridList('#alive')):
				es.server.queuecmd('es_prop_dynamic_create %s roller_spikes.mdl'%userid)
				gamethread.delayed(0.05, do_stuff, userid)
			else:
				es.dbgmsg(0, 'Not enough players to continue!')
		else:
			es.tell(userid, '#multi', '#greenInvalid syntax -- #lightgreendisco <x> <y> <z>#green You can get your x y and z by typing #lightgreencl_showpos 1#green in console')
			es.tell(userid, '#green', 'The z is the height, you would probably want to have that at least 120 units above what is shown by cl_showpos 1')
	else:
		es.tell(userid, '#green', 'No Disco For You >:[')

def do_stuff(userid):
	global index
	for prop in list(es.createentitylist().keys()):
		if not prop in prop_keys:
			index = int(prop)
	es.setindexprop(index, 'CBaseEntity.m_vecOrigin', '%s,%s,%s'%(origin[0], origin[1], origin[2]))
	disco2()
	spin(index)
	es.server.queuecmd('es_xgive %s env_fog_controller'%userid)
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogdir %s %s %s\"'%(userid, 100, 100, 100))
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogstart %s\"'%(userid, fog_start_unit))
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogend %s\"'%(userid, fog_end_unit))
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogblend 1"'%userid)
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor 100 100 100\"'%userid)
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 150 150 150\"'%userid)
	es.server.queuecmd('es_xfire %s env_fog_controller turnon'%userid)
	es.lightstyle(0, 'b')
	gamethread.delayedname(disco_fog_change_time, 'change_fog', change_fog_color)
	for sound_userid in es.getUseridList():
		if enable_rick_rolled and not custom_sound:
			es.cexec(sound_userid, 'play disco/rick.wav')
		elif custom_sound:
			es.cexec(sound_userid, 'play disco/%s'%custom_sound)

def change_fog_color():
	r, g, b = random.choice(colors)
	r2, g2, b2 = random.choice(colors)
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor %s %s %s\"'%(start_userid, r, g, b))
	es.server.queuecmd('es_xfire %s env_fog_controller addoutput \"fogcolor2 %s %s %s\"'%(start_userid, r2, g2, b2))
	gamethread.delayedname(disco_fog_change_time, 'change_fog', change_fog_color)

def round_end(ev):
	stop_stuff()

def unload():
	stop_stuff()
	if es.exists('clientcommand', 'disco'):
		es.unregclientcmd('disco')
	if es.exists('clientcommand', 'stop_disco'):
		es.unregclientcmd('stop_disco')

def stop_stuff():
	gamethread.cancelDelayed('disco1')
	gamethread.cancelDelayed('spin_ball')
	gamethread.cancelDelayed('change_fog')
	es.server.queuecmd('es_xfire %s env_fog_controller turnoff'%start_userid)
	es.server.queuecmd('es_xfire %s env_fog_controller kill'%start_userid)
	es.lightstyle(0, 'g')
	for suserid in es.getUseridList():
		es.cexec(suserid, 'play cow')

def disco2():
	r, g, b = random.choice(colors)
	x, y, z = origin
	x2 = x + random.randint(length_min, length_max) * random.choice([-1, 1])
	y2 = y + random.randint(length_min, length_max) * random.choice([-1, 1])
	z2 = z + random.randint(length_min, length_max) * random.choice([-1, 1])
	x3, y3, z3 = es.getplayerlocation(random.choice(playerlib.getUseridList('#alive')))
	if not random.randint(0, 2) == 0:
		effectlib.drawLine([x, y, z], [x2, y2, z2], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x2 + 5, y2 + 5, z2], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x2 + 5, y2, z2], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
	else:
		effectlib.drawLine([x, y, z], [x3, y3, z3], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x3 + 5, y3 + 5, z3], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
		effectlib.drawLine([x, y, z], [x3 + 5, y3, z3], "materials/sprites/laser.vmt", "materials/sprites/halo01.vmt", random.randint(1, 10) / 10.0, random.randint(1, 10), random.randint(1, 25), r, g, b, 255, 10, 0, 0, 0, 0)
	gamethread.delayedname(random.randint(1, 5) / 25.0, 'disco1', disco2)


def spin(index):
	x, y, z = es.getindexprop(index, 'CPhysicsPropMultiplayer.baseclass.baseclass.baseclass.baseclass.m_angRotation').split(',')
	es.setindexprop(index, 'CPhysicsPropMultiplayer.baseclass.baseclass.baseclass.baseclass.m_angRotation', '%s,%s,%s'%(float(x) + x_spin, float(y) + y_spin, float(z) + z_spin))
	gamethread.delayedname(0.1, 'spin_ball', spin, index)

def add_sounds():
	if enable_rick_rolled and not custom_sound:
		es.stringtable('downloadables', 'sound/disco/rick.wav')
	elif custom_sound:
		es.stringtable('downloadables', 'sound/disco/%s'%custom_sound)